Unit Draw_Obj;

interface
 uses a_Mouse, BGI2, Crt, YFonts, RBasicT;

type
  Btype = Array[1..94] of byte;
Const
  CloseB  : Array[1..3] of BType =(
            (
            {0D,$00,$0A,$00,$7F,$F0,$7F,$F0,$7F,$F0,
            $7F,$F0,$7F,$F0,$40,$00,$40,$00,$7F,$F0,
            $7F,$F0,$5F,$E0,$5F,$E0,$60,$30,$7F,$F0,
            $5F,$E0,$5F,$E0,$60,$30,$7F,$F0,$5F,$E0,
            $5F,$E0,$60,$30,$7F,$F0,$5F,$E0,$5F,$E0,
            $60,$30,$7F,$F0,$5F,$E0,$5F,$E0,$60,$30,
            $7F,$F0,$5F,$E0,$5F,$E0,$60,$30,$7F,$F0,
            $5F,$E0,$5F,$E0,$60,$30,$7F,$F0,$5F,$E0,
            $5F,$E0,$7F,$F0,$7F,$F0,$40,$00,$40,$00,
            $7F,$F0,$00,$00}
            $0D,$00,$0A,$00,$80,$0C,$80,$0C,$80,$0C,
            $80,$0C,$BF,$FC,$80,$0C,$80,$0C,$BF,$FC,
            $BF,$DC,$9F,$CC,$9F,$CC,$A0,$1C,$BF,$DC,
            $9F,$CC,$9F,$CC,$A0,$1C,$BF,$DC,$9F,$CC,
            $9F,$CC,$A0,$1C,$BF,$DC,$9F,$CC,$9F,$CC,
            $A0,$1C,$BF,$DC,$9F,$CC,$9F,$CC,$A0,$1C,
            $BF,$DC,$9F,$CC,$9F,$CC,$A0,$1C,$BF,$DC,
            $9F,$CC,$9F,$CC,$A0,$1C,$A0,$1C,$80,$0C,
            $80,$0C,$A0,$1C,$BF,$FC,$80,$0C,$80,$0C,
            $BF,$FC,$03,$B0
            ),(
            {0D,$00,$0A,$00,$7F,$F0,$7F,$F0,$7F,$F0,
            $7F,$F0,$7F,$F0,$40,$10,$40,$10,$5D,$D0,
            $7F,$F0,$40,$10,$40,$10,$6D,$B0,$7F,$F0,
            $40,$10,$40,$10,$75,$70,$7F,$F0,$40,$10,
            $40,$10,$7D,$F0,$7F,$F0,$00,$00,$00,$00,
            $07,$00,$7F,$F0,$40,$10,$40,$10,$7F,$F0,
            $7F,$F0,$40,$10,$40,$10,$75,$70,$7F,$F0,
            $40,$10,$40,$10,$6D,$B0,$7F,$F0,$40,$10,
            $40,$10,$5D,$D0,$7F,$F0,$7F,$F0,$7F,$F0,
            $7F,$F0,$7F,$F0}
            $0D,$00,$0A,$00,$80,$0C,$80,$0C,$80,$0C,
            $80,$0C,$BF,$EC,$80,$0C,$80,$0C,$9D,$CC,
            $BF,$EC,$80,$0C,$80,$0C,$AD,$AC,$BF,$EC,
            $80,$0C,$80,$0C,$B5,$6C,$BF,$EC,$80,$0C,
            $80,$0C,$BD,$EC,$FF,$FC,$80,$0C,$80,$0C,
            $87,$0C,$BF,$EC,$80,$0C,$80,$0C,$BF,$EC,
            $BF,$EC,$80,$0C,$80,$0C,$B5,$6C,$BF,$EC,
            $80,$0C,$80,$0C,$AD,$AC,$BF,$EC,$80,$0C,
            $80,$0C,$9D,$CC,$80,$0C,$80,$0C,$80,$0C,
            $80,$0C,$FF,$A2
            ),(
            {0D,$00,$0A,$00,$7F,$F0,$7F,$F0,$7F,$F0,
            $7F,$F0,$7F,$F0,$40,$00,$40,$00,$7F,$F0,
            $7F,$F0,$5F,$E0,$5F,$E0,$62,$30,$7F,$F0,
            $5F,$E0,$5F,$E0,$62,$30,$7F,$F0,$5F,$E0,
            $5F,$E0,$62,$30,$7F,$F0,$5F,$E0,$5F,$E0,
            $62,$30,$7F,$F0,$5F,$E0,$5F,$E0,$7E,$30,
            $7F,$F0,$5F,$E0,$5F,$E0,$60,$30,$7F,$F0,
            $5F,$E0,$5F,$E0,$60,$30,$7F,$F0,$5F,$E0,
            $5F,$E0,$7F,$F0,$7F,$F0,$40,$00,$40,$00,
            $7F,$F0,$7F,$F0}
            $0D,$00,$0A,$00,$80,$0C,$80,$0C,$80,$0C,
            $80,$0C,$BF,$FC,$80,$0C,$80,$0C,$BF,$FC,
            $BD,$DC,$9D,$CC,$9D,$CC,$A0,$1C,$BD,$DC,
            $9D,$CC,$9D,$CC,$A0,$1C,$BD,$DC,$9D,$CC,
            $9D,$CC,$A0,$1C,$BD,$DC,$9D,$CC,$9D,$CC,
            $A0,$1C,$A1,$DC,$81,$CC,$81,$CC,$A0,$1C,
            $BF,$DC,$9F,$CC,$9F,$CC,$A0,$1C,$BF,$DC,
            $9F,$CC,$9F,$CC,$A0,$1C,$A0,$1C,$80,$0C,
            $80,$0C,$A0,$1C,$BF,$FC,$80,$0C,$80,$0C,
            $BF,$FC,$BF,$EC
            ));




Type
  MacWindow = object
                Title   : string;
                Bounds  : TRect;
                ttx     : integer;
                Constructor Init;
                Procedure Assign(px,py,px1,py1 : integer; ptitle : string);
                Procedure Draw(Active : Boolean);
                Procedure DrawTitle(ClsB, MaxB, Active : boolean);
                Procedure SetRECTS(var PTitle, PCloseB, PExpandB : TRect);
                Procedure DrawCtrls(ClsB, MaxB : Boolean);
                Procedure DrawText;
              end;

Procedure WButton2(r : Trect; pushed : boolean);
Procedure WButton(x,y,px1,py1,s : integer; text : string; Pushed, Sel : boolean);
Procedure WButton3(x,y,px1,py1,s : integer; text : string; Pushed, Sel : boolean);
Procedure QMButton(x,y,px1,py1,s : integer; text : string; Pushed, Def : boolean);

Procedure BWindow(r : TRect; title : String);
Procedure BWindowTitle(r : TRect; Title : String; Active : Boolean);
Procedure BWindowInitButtons(R : TRect; var W : WinButtons);
Procedure BWindowControls(r : TRect; MOnOff, MnOnOff, COnOff : Boolean);
Procedure Button(r : TRect; fs, Color : Byte; OnOff : boolean);
Procedure WinFace(r : TRect);
Procedure DrawBitMap(var Bitmap: Array of byte;sx, sy : word; Width, Height, Color : byte);
Procedure GCluster(r : TRect; mode : boolean);
Procedure GTick(r : TRect; mode : boolean);
Procedure MacPal;
Procedure DrawMacButton(R : TRect; Str : string; Pressed, Selected : boolean);
Procedure Pannel(R : TRect; state : boolean);
Procedure ColorPannel(R : TRect; state : boolean; Color : byte);
Procedure GetLinePos(Text : String; tx, ty, s : integer; var xx, yy, xx1 : integer);

Const
  SysFont   = 'win95.ytf';
  EditFont  = 'default.ytf';

  Color3dObj = 7;
  BorderColor = 0;
  WinActiveTitleColor = LightBlue;
  WinPassiveTitleColor = 8;
  LightBColor = 15;
  DarkBColor = 8;

  EmptyCluster : Array[1..12*12] of Byte =
  (
  00,00,00,00,00,00,00,00,00,00,00,00,
  00,00,00,00,10,10,10,10,00,00,00,00,
  00,00,00,10,00,00,00,00,10,00,00,00,
  00,00,10,00,00,00,00,00,00,10,00,00,
  00,10,00,00,00,00,00,00,00,00,10,00,
  00,10,00,00,00,00,00,00,00,00,10,00,
  00,10,00,00,00,00,00,00,00,00,10,00,
  00,10,00,00,00,00,00,00,00,00,10,00,
  00,00,10,00,00,00,00,00,00,10,00,00,
  00,00,00,10,00,00,00,00,10,00,00,00,
  00,00,00,00,10,10,10,10,00,00,00,00,
  00,00,00,00,00,00,00,00,00,00,00,00
  );

  FullCluster : Array[1..12*12] of Byte =
  (
  00,00,00,00,00,00,00,00,00,00,00,00,
  00,00,00,00,10,10,10,10,00,00,00,00,
  00,00,00,10,00,00,00,00,10,00,00,00,
  00,00,10,00,00,10,10,00,00,10,00,00,
  00,10,00,00,10,10,10,10,00,00,10,00,
  00,10,00,10,10,10,10,10,10,00,10,00,
  00,10,00,10,10,10,10,10,10,00,10,00,
  00,10,00,00,10,10,10,10,00,00,10,00,
  00,00,10,00,00,10,10,00,00,10,00,00,
  00,00,00,10,00,00,00,00,10,00,00,00,
  00,00,00,00,10,10,10,10,00,00,00,00,
  00,00,00,00,00,00,00,00,00,00,00,00
  );

  EmptyTick : Array[1..12*12] of Byte =
  (
  00,00,00,00,00,00,00,00,00,00,00,00,
  00,10,10,10,10,10,10,10,10,10,10,00,
  00,10,00,00,00,00,00,00,00,00,10,00,
  00,10,00,00,00,00,00,00,00,00,10,00,
  00,10,00,00,00,00,00,00,00,00,10,00,
  00,10,00,00,00,00,00,00,00,00,10,00,
  00,10,00,00,00,00,00,00,00,00,10,00,
  00,10,00,00,00,00,00,00,00,00,10,00,
  00,10,00,00,00,00,00,00,00,00,10,00,
  00,10,00,00,00,00,00,00,00,00,10,00,
  00,10,10,10,10,10,10,10,10,10,10,00,
  00,00,00,00,00,00,00,00,00,00,00,00
  );

  FullTick : Array[1..12*12] of Byte =
  (
  00,00,00,00,00,00,00,00,00,00,00,00,
  00,10,10,10,10,10,10,10,10,10,10,00,
  00,10,10,00,00,00,00,00,00,10,10,00,
  00,10,00,10,00,00,00,00,10,00,10,00,
  00,10,00,00,10,00,00,10,00,00,10,00,
  00,10,00,00,00,10,10,00,00,00,10,00,
  00,10,00,00,00,10,10,00,00,00,10,00,
  00,10,00,00,10,00,00,10,00,00,10,00,
  00,10,00,10,00,00,00,00,10,00,10,00,
  00,10,10,00,00,00,00,00,00,10,10,00,
  00,10,10,10,10,10,10,10,10,10,10,00,
  00,00,00,00,00,00,00,00,00,00,00,00
  );

  WinX : Array[1..12*12] of Byte =
  (
  00,00,00,00,00,00,00,00,00,00,00,00,
  00,10,10,00,00,00,00,00,00,10,10,00,
  00,00,10,10,00,00,00,00,10,10,00,00,
  00,00,00,10,10,00,00,10,10,00,00,00,
  00,00,00,00,10,10,10,10,00,00,00,00,
  00,00,00,00,00,10,10,00,00,00,00,00,
  00,00,00,00,10,10,10,10,00,00,00,00,
  00,00,00,10,10,00,00,10,10,00,00,00,
  00,00,10,10,00,00,00,00,10,10,00,00,
  00,10,10,00,00,00,00,00,00,10,10,00,
  00,00,00,00,00,00,00,00,00,00,00,00,
  00,00,00,00,00,00,00,00,00,00,00,00
  );

  StatusLine : Array[1..15*15] of Byte =
  (
  00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,
  00,00,00,00,00,00,00,00,00,00,00,00,00,15,00,
  00,00,00,00,00,00,00,00,00,00,00,00,15,00,00,
  00,00,00,00,00,00,00,00,00,00,00,15,00,08,00,
  00,00,00,00,00,00,00,00,00,00,15,00,08,00,00,
  00,00,00,00,00,00,00,00,00,15,00,08,00,15,00,
  00,00,00,00,00,00,00,00,15,00,08,00,15,00,00,
  00,00,00,00,00,00,00,15,00,08,00,15,00,08,00,
  00,00,00,00,00,00,15,00,08,00,15,00,08,00,00,
  00,00,00,00,00,15,00,08,00,15,00,08,00,15,00,
  00,00,00,00,15,00,08,00,15,00,08,00,15,00,00,
  00,00,00,15,00,08,00,15,00,08,00,15,00,08,00,
  00,00,15,00,08,00,15,00,08,00,15,00,08,00,00,
  00,15,00,08,00,15,00,08,00,15,00,08,00,00,00,
  00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
  );


implementation

Constructor MacWindow.Init;
begin
end;

Procedure MacWindow.Assign(px,py,px1,py1 : integer; ptitle : string);
begin
   Bounds.Assign(px,py,px1,py1);
   Title := PTitle;
end;

Procedure MacWindow.Draw(Active : Boolean);
var
 x,y,x1,y1 : integer;

begin
   hidemouse;
   x  := Bounds.x;  y  := Bounds.y;
   x1 := Bounds.x1; y1 := Bounds.y1;
   SetColor(0);
   {Rectangle(x,y,x1-2,y1);}
   Line(x,y,x,y1-1);
   Line(x+1,y+18,x1-3,y+18);

   Line(x+1,y1-1,x1-3,y1-1);
   Line(x+1,y1,x1-3,y1);

   Line(x1-1,y+1,x1-1,y1);
   Line(x1-2,y+1,x1-2,y1);

   SetFillStyle(1,15);
   Bar(x+1,y+19,x1-3,y1-2);
   DrawTitle(False,False,Active);
   showmouse;
end;

Procedure MacWindow.SetRECTS(var PTitle, PCloseB, PExpandB : TRect);
var
  x,y,x1,y1 : integer;
begin
   x  := Bounds.x;  y  := Bounds.y;
   x1 := Bounds.x1; y1 := Bounds.y1;
   PTitle.Assign(x+1,y,x1-3,y+17);
   PCloseB.Assign(x+10,y+4,x+21,y+14);
   PExpandB.Assign(x-22,y+4,x-11,y+14);
end;

Procedure MacWindow.DrawText;
var
 x,y,x1,y1 : integer;
 tx,tx1, middle : integer;

begin
   x  := Bounds.x;  y  := Bounds.y;
   x1 := Bounds.x1; y1 := Bounds.y1;
   Curr := 2;
   Middle := (x+1)+(((x1-2)-(x+1))div 2);
   tx := (Middle - (YTextWidth(Title) div 2))-5;
   tx1 := tx+YTextWidth(Title)+10;
   SetFillStyle(1,15);
   Bar(tx,y+2,tx1,y+16);
   MoveTo(tx+5,y+3);
   YOutText(Title);
   Curr := 1;
end;

Procedure MacWindow.DrawTitle(ClsB, MaxB, Active : boolean);
var
 x,y,x1,y1 : integer;
 i,tx,tx1, middle : integer;
begin
   hidemouse;
   x  := Bounds.x;  y  := Bounds.y;
   x1 := Bounds.x1; y1 := Bounds.y1;
   SetFillStyle(1,15);
   Bar(x+1,y+1,x1-3,y+17);
   if active then
   begin
      SetColor(9);
      Rectangle(x+1,y+1,x1-3,y+17);
      SetColor(1);
      Line(x+1,y+17,x1-3,y+17);
      Line(x1-3,y+17,x1-3,y+1);
      SetColor(8);
      for i := 1 to 6 do
      Line(x+3,y+i*2+2,x1-5,y+i*2+2);
      SetColor(0);
      DrawText;
      DrawCtrls(ClsB,MaxB);
      SetColor(0);
      line(x+1,y,x1-3,y);
   end
  else
   begin
      SetColor(7);
      DrawText;
      SetColor(0);
      line(x+1,y,x1-3,y);
   end;
   showmouse;
end;

Procedure MacWindow.DrawCtrls(ClsB, MaxB : Boolean);
var
  mode : integer;
  x,y,x1,y1 : integer;
begin
   x  := Bounds.x;  y  := Bounds.y;
   x1 := Bounds.x1; y1 := Bounds.y1;
   hidemouse;
   if ClsB then Mode := 2
  else Mode := 1;
   PutImage(x+9,y+4,CloseB[Mode],0);
   if MaxB then Mode := 2
  else Mode := 3;
   PutImage(x1-23,y+4,CloseB[Mode],0);
   showmouse;
end;

{harder: 36 36 63}    {lighter: 54 54 63}  {8: 27 27 21}
                               {Close butt:45 45 42}
Procedure MacPal;
begin
   Pal(3,0,32,32);
   Pal(8,27,27,21);
   Pal(1,36,36,63);
   Pal(9,54,54,63);
   pal(14,45,45,42);
end;


Procedure DrawX(X,Y, X1,Y1 : integer; Param : byte);
begin
   case Param of

       1 : begin
              Line(x1-17,y+6,x1-9,y+14);
              Line(x1-17,y+7,x1-9,y+15);
              Line(x1-17,y+14,x1-8,y+6);
              Line(x1-17,y+15,x1-8,y+7);
           end;

       2 : begin
              Rectangle(x1-39,y+6,x1-27,y+15);
              Line(x1-39,y+7,x1-27,y+7); Line(x1-39,y+8,x1-27,y+8);
           end;

       3 : begin
              Line(x1-56,y+15,x1-47,y+15); Line(x1-56,y+14,x1-47,y+14);
           end;
   end;
end;


Procedure WButton2(r : Trect; pushed : boolean);
var
 x,y,x1,y1 : integer;
begin
   x := r.x;
   x1 := r.x1;
   y := r.y;
   y1 := r.y1;
   HideMouse;
   setcolor(15);
   if not Pushed then
   begin
      SetColor(0);
      SetFillStyle(1,7);
      Bar(x,y,x1,y1);
      Rectangle(x,y,x1,y1);
      SetColor(3);
      Line(x+1,y+1,x1-2,y+1);
      Line(x+1,y+1,x+1,y1-2);
      SetColor(15);
      Line(x,y,x1-1,y);
      Line(x,y,x,y1-1);
      SetColor(8);
      Line(x+1,y1-1,x1-1,y1-1);
      Line(x1-1,y+1,x1-1,y1-1);
   end
  else
   begin
      SetColor(15);
      SetFillStyle(1,7);
      Bar(x,y,x1,y1);
      Rectangle(x,y,x1,y1);
      SetColor(8);
      Line(x+1,y+1,x1-2,y+1);
      Line(x+1,y+1,x+1,y1-2);
      SetColor(0);
      Line(x,y,x1-1,y);
      Line(x,y,x,y1-1);
   end;
   ShowMouse;
end;

Procedure GetLinePos(Text : String; tx, ty, s : integer; var xx, yy, xx1 : integer);
begin
   xx := tx+YTextWidth(Copy(text,1,s-1));
   yy := ty+YTextHeight('H')-2;
   xx1 := xx+YTextWidth(text[s]);
   if (xx1-xx) > 5 then dec(xx1,2);
end;

Procedure WButton(x,y,px1,py1,s : integer; text : string; Pushed, Sel : boolean);
var
 X1, Y1 : integer;
 tx,ty  : integer;
 xx,yy,xx1 : integer;
 r      : TRect;
begin
   HideMouse;
   X1 := px1;
   Y1 := py1;
   setcolor(LightBColor);


   if not Pushed then
   begin
      r.assign(x,y,x1,y1);
      WButton2(r,False);
      tx := X + 11;
      ty := ((Y+Y1) div 2)-(YTextHeight(text) div 2)+1;
      MoveTo(tx,ty);
      setcolor(BorderColor);
      YOutText(text);
   end
  else
   begin
      r.assign(x,y,x1,y1);
      WButton2(r,True);
      tx := X+12;
      ty := ((Y+Y1) div 2)-(YTextHeight(text) div 2)+2;
      MoveTo(tx,ty);
      setcolor(0);
      YOutText(text);
   end;
   if s > 0 then
     GetLinePos(Text, tx, ty, s, xx, yy, xx1);
   Line(xx,yy,xx1,yy);
   if Sel then
    SetColor(0)
   else
    SetColor(WinFaceColor);
   Rectangle(x-1,y-1,x1+1,y1+1);
   ShowMouse;
end;

Procedure WButton3(x,y,px1,py1,s : integer; text : string; Pushed, Sel : boolean);
var
 X1, Y1 : integer;
 tx,ty  : integer;
 xx,yy,xx1 : integer;
 r      : TRect;
begin
   HideMouse;
   X1 := px1;
   Y1 := py1;
   setcolor(LightBColor);

   if not Pushed then
   begin
      r.assign(x,y,x1,y1);
      Button(r,1,7,False);
      tx := X + 11;
      ty := ((Y+Y1) div 2)-(YTextHeight(text) div 2)+1;
      MoveTo(tx,ty);
      setcolor(BorderColor);
      YOutText(text);
   end
  else
   begin
      r.assign(x,y,x1,y1);
      Button(r,1,7,True);
      tx := X+12;
      ty := ((Y+Y1) div 2)-(YTextHeight(text) div 2)+2;
      MoveTo(tx,ty);
      setcolor(0);
      YOutText(text);
   end;
   if s > 0 then
     GetLinePos(Text, tx, ty, s, xx, yy, xx1);
   Line(xx,yy,xx1,yy);
   if Sel then
    SetColor(0)
   else
    SetColor(WinFaceColor);
   Rectangle(x-1,y-1,x1+1,y1+1);
   ShowMouse;
end;


Procedure QMButton(x,y,px1,py1,s : integer; text : string; Pushed, Def : boolean);
var
 X1, Y1 : integer;
 xx, xx1, yy : integer;
begin
   HideMouse;
   X1 := px1;
   Y1 := py1;
   setcolor(15);
   if not Pushed then
   begin
      SetColor(0);
      SetFillStyle(1,7);
      Bar(x,y,x1,y1);
      Rectangle(x,y,x1,y1);
      SetColor(15);
      Line(x+1,y+1,x1-2,y+1);
      Line(x+1,y+1,x+1,y1-2);
      SetColor(8);
      Line(x+1,y1-1,x1-1,y1-1);
      Line(x1-1,y+1,x1-1,y1-1);
      SysF := True;
      MoveTo(X+11,((Y+Y1) div 2)-(YTextHeight(text) div 2)+2);
      GetLinePos(Text, GetX, GetY, S, xx,yy,xx1);
      setcolor(0);
      YOutText(text);
      MoveTo(X+10,((Y+Y1) div 2)-(YTextHeight(text) div 2)+1);
      setcolor(15);
      YOutText(text);
      Inc(yy,3);
{      Dec(xx,1); Dec(xx1,1);}
      SetColor(0);
      Line(xx,yy,xx1,yy);
      SetColor(15);
      Line(xx-1,yy-1,xx1-1,yy-1);
{      Line(xx-1,yy-2,xx1-2,yy-1);}
   end
  else
   begin
      SetColor(0);
      SetFillStyle(1,7);
      Bar(x,y,x1,y1);
      Rectangle(x,y,x1,y1);
      SetColor(8);
      Line(x+1,y+1,x1-1,y+1);
      Line(x+1,y+1,x+1,y1-1);
      SetColor(15);
      Line(x+2,y1-1,x1-2,y1-1);
      Line(x1-1,y+2,x1-1,y1-1);
      SysF := True;
      MoveTo(X+11,((Y+Y1) div 2)-(YTextHeight(text) div 2)+3);
      setcolor(15);
      YOutText(text);
      MoveTo(X+10,((Y+Y1) div 2)-(YTextHeight(text) div 2)+2);
      setcolor(0);
      YOutText(text);
   end;
   if Def then
   begin
      SetColor(0);
      Rectangle(x-1,y-1,x1+1,y1+1);
   end
  else
   begin
      SetColor(7);
      Rectangle(x-1,y-1,x1+1,y1+1);
   end;
   ShowMouse;
   SysF := False;
end;


Procedure Button(r : TRect; fs, Color : Byte; OnOff : boolean);
begin
   HideMouse;
   SetColor(DarkBColor);
   Rectangle(R.X,R.Y,R.X1,R.Y1);
   if not OnOff then
   begin
      SetColor(LightBColor);
      Line(R.X,R.Y,R.X1,R.Y);
      Line(R.X,R.Y,R.X,R.Y1);
      PutPixel(R.X,R.Y1,7);
      PutPixel(R.X1,R.Y,7);
    end
   else
    begin
      SetColor(LightBColor);
      Line(R.X1,R.Y1,R.X1,R.Y);
      Line(R.X1,R.Y1,R.X,R.Y1);
      PutPixel(R.X,R.Y1,7);
      PutPixel(R.X1,R.Y,7);
    end;
   SetFillStyle(fs,Color);
   Bar(R.X+1,R.Y+1,R.X1-1,R.Y1-1);
   ShowMouse;
end;

Procedure BWindowInitButtons(R : TRect; var W : WinButtons);
begin
   Inc(r.x,3);
   Inc(r.y,3);
   Dec(r.x1,1);
   Dec(r.y1,1);
{   W.MenuB.Assign(r.x,r.y,r.x+20,r.y+20); }     {Menu Button}
   W.MenuB.Assign(0,0,0,0);
   W.MiniB.Assign(r.x1-36,r.y+3,r.x1-21,r.y+17); {Minimize Button}
   W.ClosB.Assign(r.x1-22,r.y+5,r.x1-8,r.y+18);    {Close Button}
   W.Title.Assign(r.x,r.y,r.x1,r.y+24);  {Title Rect}
end;

Procedure BWindowControls(r : TRect; MOnOff, MnOnOff, COnOff : Boolean);
var
 W : WinButtons;
begin
   HideMouse;
   BWindowInitButtons(r,W);

   Button(W.ClosB,1,7,COnOff);                {Close Button}
   DrawBitMap(WinX,W.ClosB.x+2,W.ClosB.y+2,12,11,0);
   ShowMouse;
end;

Procedure BWindowTitle(r : TRect; Title : String; Active : Boolean);
var
 Br : TRect;
 Lr : TRect;
 Tr : TRect;
begin
   HideMouse;
   SetColor(0);
   Lr := r;
   Br.Assign(r.x,r.y,r.x1,r.y+20);
   {if Active then
     SetFillstyle(1,1)
    else
     SetFillstyle(1,8);}

   Tr.Assign(r.x+5,r.y+5,r.x1-5,r.y+24);
   if Active then
     ColorPannel(tr,False,1)
    else
     ColorPannel(tr,False,8);
   BWindowControls(Lr, False, False, False);
   if YTextWidth(title) < (r.x1-r.x)-5 then
   begin
      SetColor(15);
      MoveTo(r.GetMiddleX-(YTextWidth(Title)div 2)-5,r.y+9);
      YOutTextB(Title);
   end;
   ShowMouse;
end;

Procedure WinBut(r : TRect);
var
 x,y,x1,y1 : integer;
begin
   x := r.x;
   y := r.y;
   x1 := r.x1;
   y1 := r.y1;
   HideMouse;
   SetColor(0);
   SetFillStyle(1,3);
   Bar(x,y,x1,y1);
   Rectangle(x,y,x1,y1);
   SetColor(7);
   Line(x,y,x1-1,y);
   Line(x,y,x,y1-1);
   SetColor(15);
   Line(x+1,y+1,x1-2,y+1);
   Line(x+1,y+1,x+1,y1-2);
   SetColor(8);
   Line(x+1,y1-1,x1-1,y1-1);
   Line(x1-1,y1-1,x1-1,y+1);
   ShowMouse;
end;


Procedure BWindow(r : TRect; title : String);
var
 Br : TRect;
begin
   WinBut(r);
   BWindowTitle(R, Title, True);
   SetColor(0);
   SetWriteMode(NormalPut);
end;

Procedure WinFace(r : TRect);
var
 x,y,x1,y1 : integer;
begin
   x := r.x;  y := r.y;
   x1:= r.x1; y1:= r.y1;
   HideMouse;
   SetFillStyle(1,15);
   Bar(x,y,x1,y1);
   SetColor(8);
   Line(x,y,x1-1,y);
   Line(x,y,x,y1-1);
   SetColor(0);
   Line(x+1,y+1,x1-2,y+1);
   Line(x+1,y+1,x+1,y1-2);
   SetColor(7);
   Line(x+1,y1-1,x1-1,y1-1);
   Line(x1-1,y1-1,x1-1,y+1);
   ShowMouse;
end;

Procedure DrawBitMap(var Bitmap : Array of byte; sx,sy : word; Width, Height, Color : byte);
var
 x,y : byte;
begin
   for y := 1 to height do
    for x := 1 to width do
     if Bitmap[((y-1)*Width)+x] = 10 then
       PutPixel(sx+(x-1),sy+(y-1),Color)
      else
       if Bitmap[((y-1)*Width)+x] <> 0 then
         PutPixel(sx+(x-1),sy+(y-1),Bitmap[((y-1)*Width)+x]);
end;

Procedure GCluster(r : TRect; mode : boolean);
begin
   SetColor(BorderColor);
   SetFillStyle(1,Color3dObj);
   Bar(r.x,r.y,r.x+12,r.y+12);
   if mode then
     DrawBitMap(FullCluster,r.x,r.y,12,12,0)
   else
     DrawBitMap(EmptyCluster,r.x,r.y,12,12,0);
end;

Procedure GTick(r : TRect; mode : boolean);
begin
   SetColor(BorderColor);
   SetFillStyle(1,Color3dObj);
   Bar(r.x,r.y,r.x+12,r.y+12);
   if mode then
     DrawBitMap(FullTick,r.x,r.y,12,12,0)
   else
     DrawBitMap(EmptyTick,r.x,r.y,12,12,0);
end;

Procedure MacBtnRect(x,y,x1,y1 : Integer);
Begin
   line(x+3,y,x1-3,y);
   line(x+3,y1,x1-3,y1);
   line(x,y+3,x,y1-3);
   line(x1,y+3,x1,y1-3);

   PutPixel(x+1,y+2,GetColor);    { draws }
   PutPixel(x+1,y+1,GetColor);    {  00   }
   PutPixel(x+2,y+1,GetColor);    {  0    }

   PutPixel(x+1,y1-2,GetColor);
   PutPixel(x+1,y1-1,GetColor);
   PutPixel(x+2,y1-1,GetColor);

   PutPixel(x1-2,y+1,GetColor);
   PutPixel(x1-1,y+1,GetColor);
   PutPixel(x1-1,y+2,GetColor);

   PutPixel(x1-2,y1-1,GetColor);
   PutPixel(x1-1,y1-1,GetColor);
   PutPixel(x1-1,y1-2,GetColor);
End;

Procedure DrawMacButton(R : TRect; Str : string; Pressed, Selected : boolean);
var
 tx : integer;
 ty : integer;
begin
   if selected then
     setcolor(0)
    else
     setcolor(15);
   MacBtnRect(R.x,R.y,R.x1,R.y1);
   Inc(R.x,2);
   Inc(R.y,2);
   Dec(R.x1,2);
   Dec(R.y1,2);
   setcolor(0);
   MacBtnRect(R.x,R.y,R.x1,R.y1);
   if Pressed then
   begin
     SetFillStyle(1,0);
     SetColor(0);
   end
  else
   begin
     SetFillStyle(1,15);
     SetColor(15);
   end;
   bar(R.x+2,R.y+2,R.x1-2,R.y1-2);
   line(R.x+3,R.y+1,R.x1-3,R.y+1);
   line(R.x+3,R.y1-1,R.x1-3,R.y1-1);
   line(R.x+1,R.y+3,R.x+1,R.y1-3);
   line(R.x1-1,R.y+3,R.x1-1,R.y1-3);
   if Pressed then SetColor(15)
  else
   SetColor(0);
   Curr := 2;
   tx := R.GetMiddleX - (YTextWidth(Str) div 2);
   ty := R.GetMiddleY - (YTextHeight(Str) div 2);
   MoveTo(tx,ty);
   YOutText(Str);
end;

Procedure Pannel(R : TRect; state : boolean);
var
 C1, C2 : byte;
begin
   C1 := 8;
   C2 := 15;
   if State then
   begin
      C1 := 15;
      C2 := 8;
   end;
   SetColor(C1);
   Rectangle(r.x,r.y,r.x1,r.y1);
   SetColor(C2);
   Line(r.x,r.y1,r.x1,r.y1);
   Line(r.x1,r.y,r.x1,r.y1);
end;

Procedure ColorPannel(R : TRect; state : boolean; Color : byte);
begin
   SetFillStyle(1,Color);
   Bar(R.x, R.y, R.x1, R.y1);
   Pannel(R, State);
end;

begin
   LoadYTF('win95.ytf');
   LoadYTF('Mac.ytf');
end.
