Unit Keys;

interface
  uses Crt;

Type
  KeysT = (K_Up, K_Down, K_Left, K_Right);

var
  KUp,
  KDown,
  KRight,
  KLeft,
  KSpace,
  KeysReset : Boolean;

Procedure GetKeys;
Procedure ResetKeys;

implementation

Procedure ResetKeys;
begin
   KUp := False;
   KDown := False;
   KLeft := False;
   KRight := False;
   KSpace := False;
   while keypressed do readkey;
end;

{    Up_Key    : Char = #72;
     Down_Key  : Char = #80;
     Right_Key : Char = #77;
     Left_Key  : Char = #75;}

Procedure GetKeys;
var
 ch : char;
begin
   case PORT[$60] of

      80 : begin
              ResetKeys;
              KDown := True;
           end;
      77 : begin
              ResetKeys;
              KRight := True;
           end;
      75 : begin
              ResetKeys;
              KLeft := True;
           end;

      57  : KSpace := True;
      185 : KSpace := False;

      200 : KUp := False;
      208 : KDown := False;
      205 : KRight := False;
      203 : KLeft := False;

      170    : begin
                  ResetKeys;
                  KeysReset := True;
               end;
      184    : ResetKeys;

   end;
end;

begin
end.